std::bitset< _Nb >(3cxx)

NAME
std::bitset< _Nb >

SYNOPSIS

Inherits std::_Base_bitset<((_Nb)/(__CHAR_BIT__ *__SIZEOF_LONG__)+((_Nb) %(__CHAR_BIT__ *__SIZEOF_LONG__)==0 ? 0 :1))>.

  Classes

class reference

  Public Member Functions

constexpr bitset () noexcept
constexpr bitset (unsigned long long __val) noexcept
template<class _CharT , class _Traits , class _Alloc > bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position=0)
template<class _CharT , class _Traits , class _Alloc > bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position, size_t __n)
template<class _CharT , class _Traits , class _Alloc > bitset (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __position, size_t __n, _CharT __zero, _CharT __one=_CharT('1'))
template<typename _CharT > bitset (const _CharT *__str, typename std::basic_string< _CharT >::size_type __n=std::basic_string< _CharT >::npos, _CharT __zero=_CharT('0'), _CharT __one=_CharT('1'))
size_t _Find_first () const noexcept
size_t _Find_next (size_t __prev) const noexcept
template<class _CharT , class _Traits > void _M_copy_from_ptr (const _CharT *, size_t, size_t, size_t, _CharT, _CharT)
template<class _CharT , class _Traits , class _Alloc > void _M_copy_from_string (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __pos, size_t __n, _CharT __zero, _CharT __one)
template<class _CharT , class _Traits , class _Alloc > void _M_copy_from_string (const std::basic_string< _CharT, _Traits, _Alloc > &__s, size_t __pos, size_t __n)
template<class _CharT , class _Traits , class _Alloc > void _M_copy_to_string (std::basic_string< _CharT, _Traits, _Alloc > &, _CharT, _CharT) const
template<class _CharT , class _Traits , class _Alloc > void _M_copy_to_string (std::basic_string< _CharT, _Traits, _Alloc > &__s) const
bool all () const noexcept
bool any () const noexcept
size_t count () const noexcept
bitset< _Nb > & flip () noexcept
bitset< _Nb > & flip (size_t __position)
bool none () const noexcept
bitset< _Nb > operator~ () const noexcept
bitset< _Nb > & reset () noexcept
bitset< _Nb > & reset (size_t __position)
bitset< _Nb > & set () noexcept
bitset< _Nb > & set (size_t __position, bool __val=true)
constexpr size_t size () const noexcept
bool test (size_t __position) const
template<class _CharT , class _Traits , class _Alloc > std::basic_string< _CharT, _Traits, _Alloc > to_string () const
template<class _CharT , class _Traits , class _Alloc > std::basic_string< _CharT, _Traits, _Alloc > to_string (_CharT __zero, _CharT __one=_CharT('1')) const
template<class _CharT , class _Traits > std::basic_string< _CharT, _Traits, std::allocator< _CharT > > to_string () const
template<class _CharT , class _Traits > std::basic_string< _CharT, _Traits, std::allocator< _CharT > > to_string (_CharT __zero, _CharT __one=_CharT('1')) const
template<class _CharT > std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > to_string () const
template<class _CharT > std::basic_string< _CharT, std::char_traits< _CharT >, std::allocator< _CharT > > to_string (_CharT __zero, _CharT __one=_CharT('1')) const
std::basic_string< char, std::char_traits< char >, std::allocator< char > > to_string () const
std::basic_string< char, std::char_traits< char >, std::allocator< char > > to_string (char __zero, char __one='1') const
unsigned long long to_ullong () const
unsigned long to_ulong () const

bitset< _Nb > & operator &= (const bitset< _Nb > &__rhs) noexcept
bitset< _Nb > & operator|= (const bitset< _Nb > &__rhs) noexcept
bitset< _Nb > & operator^= (const bitset< _Nb > &__rhs) noexcept

bitset< _Nb > & operator<<= (size_t __position) noexcept
bitset< _Nb > & operator>>= (size_t __position) noexcept

bitset< _Nb > & _Unchecked_set (size_t __pos) noexcept
bitset< _Nb > & _Unchecked_set (size_t __pos, int __val) noexcept
bitset< _Nb > & _Unchecked_reset (size_t __pos) noexcept
bitset< _Nb > & _Unchecked_flip (size_t __pos) noexcept
constexpr bool _Unchecked_test (size_t __pos) const noexcept

reference operator[] (size_t __position)
constexpr bool operator[] (size_t __position) const

bool operator== (const bitset< _Nb > &__rhs) const noexcept
bool operator!= (const bitset< _Nb > &__rhs) const noexcept

bitset< _Nb > operator<< (size_t __position) const noexcept
bitset< _Nb > operator>> (size_t __position) const noexcept

  Private Member Functions

bool _M_are_all () const noexcept
void _M_do_and (const _Base_bitset< _Nw > &__x) noexcept
size_t _M_do_count () const noexcept
size_t _M_do_find_first (size_t) const noexcept
size_t _M_do_find_next (size_t, size_t) const noexcept
void _M_do_flip () noexcept
void _M_do_left_shift (size_t __shift) noexcept
void _M_do_or (const _Base_bitset< _Nw > &__x) noexcept
void _M_do_reset () noexcept
void _M_do_right_shift (size_t __shift) noexcept
void _M_do_set () noexcept
unsigned long long _M_do_to_ullong () const
unsigned long _M_do_to_ulong () const
void _M_do_xor (const _Base_bitset< _Nw > &__x) noexcept
const _WordT * _M_getdata () const noexcept
_WordT & _M_getword (size_t __pos) noexcept
constexpr _WordT _M_getword (size_t __pos) const noexcept
_WordT & _M_hiword () noexcept
constexpr _WordT _M_hiword () const noexcept
bool _M_is_any () const noexcept
bool _M_is_equal (const _Base_bitset< _Nw > &__x) const noexcept

  Static Private Member Functions

static constexpr _WordT _S_maskbit (size_t __pos) noexcept
static constexpr size_t _S_whichbit (size_t __pos) noexcept
static constexpr size_t _S_whichbyte (size_t __pos) noexcept
static constexpr size_t _S_whichword (size_t __pos) noexcept

  Private Attributes

_WordT _M_w [_Nw]

  Friends

template<typename > struct hash
class reference

Detailed Description

  template<size_t _Nb>
class std::bitset< _Nb >" The bitset class represents a fixed-size sequence of bits.

(Note that bitset does not meet the formal requirements of a container. Mainly, it lacks iterators.)

The template argument, Nb, may be any non-negative number, specifying the number of bits (e.g., '0', '12', '1024*1024').

In the general unoptimized case, storage is allocated in word-sized blocks. Let B be the number of bits in a word, then (Nb+(B-1))/B words will be used for storage. B - NbB bits are unused. (They are the high-order bits in the highest word.) It is a class invariant that those unused bits are always zero.

If you think of bitset as a simple array of bits, be aware that your mental picture is reversed: a bitset behaves the same way as bits in integers do, with the bit at index 0 in the least significant / right-hand position, and the bit at index Nb-1 in the most significant / left-hand position. Thus, unlike other containers, a bitset's index counts from right to left, to put it very loosely.

This behavior is preserved when translating to and from strings. For example, the first line of the following program probably prints b('a') is 0001100001 on a modern ASCII system.

#include <bitset>
#include <iostream>
#include <sstream>

using namespace std;

int main()
{
    long         a = 'a';
    bitset<10>   b(a);

    cout << "b('a') is " << b << endl;

    ostringstream s;
    s << b;
    string  str = s.str();
    cout << "index 3 in the string is " << str[3] << " but
         << "index 3 in the bitset is " << b[3] << endl;
}

Also see: https://gcc.gnu.org/onlinedocs/libstdc++/manual/ext_containers.html for a description of extensions.

Most of the actual code isn't contained in bitset<> itself, but in the base class _Base_bitset. The base class works with whole words, not with individual bits. This allows us to specialize _Base_bitset for the important special case where the bitset is only a single word.

Extra confusion can result due to the fact that the storage for _Base_bitset is a regular array, and is indexed as such. This is carefully encapsulated.

Definition at line 747 of file bitset.

Constructor & Destructor Documentation

  template<size_t _Nb> constexpr std::bitset< _Nb >::bitset () [inline], [noexcept]

All bits set to zero.

Definition at line 861 of file bitset.

  template<size_t _Nb> constexpr std::bitset< _Nb >::bitset (unsigned long long __val) [inline], [noexcept]

Initial bits bitwise-copied from a single word (others set to zero).

Definition at line 866 of file bitset.

  template<size_t _Nb> template<class _CharT , class _Traits , class _Alloc > std::bitset< _Nb >::bitset (const std::basic_string< _CharT, _Traits, _Alloc > & __s, size_t __position = 0) [inline], [explicit]
Use a subset of a string.

Parameters:
    __s A string of 0 and 1 characters.
    __position Index of the first character in __s to use; defaults to zero.

Exceptions:
    std::out_of_range If pos is bigger the size of __s.
    std::invalid_argument If a character appears in the string which is neither 0 nor 1.

Definition at line 885 of file bitset.

  template<size_t _Nb> template<class _CharT , class _Traits , class _Alloc > std::bitset< _Nb >::bitset (const std::basic_string< _CharT, _Traits, _Alloc > & __s, size_t __position, size_t __n) [inline]
Use a subset of a string.

Parameters:
    __s A string of 0 and 1 characters.
    __position Index of the first character in __s to use.
    __n The number of characters to copy.

Exceptions:
    std::out_of_range If __position is bigger the size of __s.
    std::invalid_argument If a character appears in the string which is neither 0 nor 1.

Definition at line 906 of file bitset.

  template<size_t _Nb> template<typename _CharT > std::bitset< _Nb >::bitset (const _CharT * __str, typename std::basic_string< _CharT >::size_type __n = std::basic_string<_CharT>::npos, _CharT __zero = _CharT('0'), _CharT __one = _CharT('1')) [inline], [explicit]
Construct from a character array.

Parameters:
    __str An array of characters zero and one.
    __n The number of characters to use.
    __zero The character corresponding to the value 0.
    __one The character corresponding to the value 1.

Exceptions:
    std::invalid_argument If a character appears in the string which is neither __zero nor __one.

Definition at line 938 of file bitset.

Member Function Documentation

  template<size_t _Nb> bool std::bitset< _Nb >::all () const [inline], [noexcept]

Tests whether all the bits are on.

Returns:
    True if all the bits are set.

Definition at line 1326 of file bitset.

  template<size_t _Nb> bool std::bitset< _Nb >::any () const [inline], [noexcept]

Tests whether any of the bits are on.

Returns:
    True if at least one bit is set.

Definition at line 1334 of file bitset.

  template<size_t _Nb> size_t std::bitset< _Nb >::count () const [inline], [noexcept]

Returns the number of bits which are set.

Definition at line 1287 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::flip () [inline], [noexcept]

Toggles every bit to its opposite value.

Definition at line 1115 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::flip (size_t __position) [inline]

Toggles a given bit to its opposite value.

Parameters:
    __position The index of the bit.

Exceptions:
    std::out_of_range If pos is bigger the size of the set.

Definition at line 1128 of file bitset.

  template<size_t _Nb> bool std::bitset< _Nb >::none () const [inline], [noexcept]

Tests whether any of the bits are on.

Returns:
    True if none of the bits are set.

Definition at line 1342 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::operator&= (const bitset< _Nb > & __rhs) [inline], [noexcept]
Operations on bitsets.

Parameters:
    __rhs A same-sized bitset.

These should be self-explanatory.

Definition at line 964 of file bitset.

  template<size_t _Nb> bool std::bitset< _Nb >::operator!= (const bitset< _Nb > & __rhs) const [inline], [noexcept]

These comparisons for equality/inequality are, well, bitwise.

Definition at line 1302 of file bitset.

  template<size_t _Nb> bitset<_Nb> std::bitset< _Nb >::operator<< (size_t __position) const [inline], [noexcept]

Self-explanatory.

Definition at line 1348 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::operator<<= (size_t __position) [inline], [noexcept]
Operations on bitsets.

Parameters:
    __position The number of places to shift.

These should be self-explanatory.

Definition at line 993 of file bitset.

  template<size_t _Nb> bool std::bitset< _Nb >::operator== (const bitset< _Nb > & __rhs) const [inline], [noexcept]

These comparisons for equality/inequality are, well, bitwise.

Definition at line 1298 of file bitset.

  template<size_t _Nb> bitset<_Nb> std::bitset< _Nb >::operator>> (size_t __position) const [inline], [noexcept]

Self-explanatory.

Definition at line 1352 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::operator>>= (size_t __position) [inline], [noexcept]
Operations on bitsets.

Parameters:
    __position The number of places to shift.

These should be self-explanatory.

Definition at line 1006 of file bitset.

  template<size_t _Nb> reference std::bitset< _Nb >::operator[] (size_t __position) [inline]

Array-indexing support.

Parameters:
    __position Index into the bitset.

Returns:
    A bool for a const bitset. For non-const bitsets, an instance of the reference proxy class.

Note:
    These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

_GLIBCXX_RESOLVE_LIB_DEFECTS Note that this implementation already resolves DR 11 (items 1 and 2), but does not do the range-checking required by that DR's resolution. -pme The DR has since been changed: range-checking is a precondition (users' responsibility), and these functions must not throw. -pme

Definition at line 1155 of file bitset.

  template<size_t _Nb> constexpr bool std::bitset< _Nb >::operator[] (size_t __position) const [inline]

Array-indexing support.

Parameters:
    __position Index into the bitset.

Returns:
    A bool for a const bitset. For non-const bitsets, an instance of the reference proxy class.

Note:
    These operators do no range checking and throw no exceptions, as required by DR 11 to the standard.

_GLIBCXX_RESOLVE_LIB_DEFECTS Note that this implementation already resolves DR 11 (items 1 and 2), but does not do the range-checking required by that DR's resolution. -pme The DR has since been changed: range-checking is a precondition (users' responsibility), and these functions must not throw. -pme

Definition at line 1159 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::operator^= (const bitset< _Nb > & __rhs) [inline], [noexcept]
Operations on bitsets.

Parameters:
    __rhs A same-sized bitset.

These should be self-explanatory.

Definition at line 978 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::operator|= (const bitset< _Nb > & __rhs) [inline], [noexcept]
Operations on bitsets.

Parameters:
    __rhs A same-sized bitset.

These should be self-explanatory.

Definition at line 971 of file bitset.

  template<size_t _Nb> bitset<_Nb> std::bitset< _Nb >::operator~ () const [inline], [noexcept]

See the no-argument flip().

Definition at line 1136 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::reset () [inline], [noexcept]

Sets every bit to false.

Definition at line 1091 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::reset (size_t __position) [inline]

Sets a given bit to false.

Parameters:
    __position The index of the bit.

Exceptions:
    std::out_of_range If pos is bigger the size of the set.

Same as writing set(pos,false).

Definition at line 1105 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::set () [inline], [noexcept]

Sets every bit to true.

Definition at line 1067 of file bitset.

  template<size_t _Nb> bitset<_Nb>& std::bitset< _Nb >::set (size_t __position, bool __val = true) [inline]

Sets a given bit to a particular value.

Parameters:
    __position The index of the bit.
    __val Either true or false, defaults to true.

Exceptions:
    std::out_of_range If pos is bigger the size of the set.

Definition at line 1081 of file bitset.

  template<size_t _Nb> constexpr size_t std::bitset< _Nb >::size () const [inline], [noexcept]

Returns the total number of bits.

Definition at line 1292 of file bitset.

  template<size_t _Nb> bool std::bitset< _Nb >::test (size_t __position) const [inline]

Tests the value of a bit.

Parameters:
    __position The index of a bit.

Returns:
    The value at pos.

Exceptions:
    std::out_of_range If pos is bigger the size of the set.

Definition at line 1313 of file bitset.

  template<size_t _Nb> template<class _CharT , class _Traits , class _Alloc > std::basic_string<_CharT, _Traits, _Alloc> std::bitset< _Nb >::to_string () const [inline]

Returns a character interpretation of the bitset.

Returns:
    The string equivalent of the bits.

Note the ordering of the bits: decreasing character positions correspond to increasing bit positions (see the main class notes for an example).

Definition at line 1189 of file bitset.

  template<size_t _Nb> unsigned long std::bitset< _Nb >::to_ulong () const [inline]

Returns a numerical interpretation of the bitset.

Returns:
    The integral equivalent of the bits.

Exceptions:
    std::overflow_error If there are too many bits to be represented in an unsigned long.

Definition at line 1170 of file bitset.

Author

Generated automatically by Doxygen for libstdc++ from the source code.